﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
using HeuristicLab.Common;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public abstract class Expression : DeepCloneable
    {
        public Expression() { }

        public Expression(string stringRepresenation) : this(stringRepresenation, stringRepresenation.GetHashCode())
        { }

        public Expression(string stringRepresenation, int id)
        {
            this.StringRepresentation = stringRepresenation;
            this.Id = id;
        }

        // copy constructor
        public Expression(Expression original, Cloner cloner) : base(original, cloner)
        {
            this.StringRepresentation = original.StringRepresentation;
            this.Id = original.Id;
        }

        protected int Id { get; set; }
        protected string StringRepresentation { get; set; }

        public abstract void Eval(IInterpreter interpreter);

        public override string ToString()
        {
            return this.StringRepresentation;
        }

        public override bool Equals(object obj)
        {
            return obj != null && this.GetType() == obj.GetType();
        }

        public override int GetHashCode()
        {
            return this.Id;
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return this;
        }
    }
}